<?    

if (isset($_POST['op'])) {
    switch ($_POST['op']) {
        case 'delete':
            $start = strtotime($_POST['startdate']);
            $end   = strtotime($_POST['enddate'])+24*3600-1;
            
            $run = 1;
            
            while ($run == 1) {
                $query = 'select * from tr_visits where start_time>'.$start.' and start_time<='.$end.' limit 0,1000';
                $visits = $wpdb->get_results($query);
                
//                print $query;
                
                if (count($visits) > 0) {
                    
                    foreach ($visits as $v) {
                        // delete pages
                        $wpdb->query('delete from tr_pages where ssid="'.$v->ssid.'";');
                        $wpdb->query('delete from tr_visits where ssid="'.$v->ssid.'" limit 1;');
                        
                        // delete cache files
                        $dh = @opendir($path.'/tracker/cache/t/'.$v->ssid);
                        
                        while ($f = @readdir($dh)) {
                            if ( ($f != '.') && ($f != '..') ) {
                                @unlink($path.'/tracker/cache/t/'.$v->ssid.'/'.$f);
                            }
                        }
                        
                        @closedir($dh);
                        
                        @rmdir($path.'/tracker/cache/t/'.$v->ssid);
                    }
                } else {
                    $run = 0;
                }
                
                // clear cache files
                $cache = $wpdb->get_results('select c.cid, c.code, p.pgid from tr_cache c left outer join tr_pages p on c.cid=p.cid where p.pgid is null;');
                
                if (count($cache) > 0) {
                    foreach ($cache as $c) {
                        @unlink($path.'/tracker/cache/p/'.$c->code.'.html'); 
                        
                        $wpdb->query('delete from tr_cache where cid="'.$c->cid.'" limit 1;');   
                    }
                }
            }
            break;
        case 'ips':
            update_option('wpc_blocked_ips', $_POST['wpc_blocked_ips']);
            break;
        case 'permissions':
            if (isset($_POST['wpc_permissions_overwrite'])) update_option('wpc_permissions_overwrite', 1); else update_option('wpc_permissions_overwrite', 0);
            
            update_option('wpc_permissions_files', $_POST['wpc_permissions_files']);
            update_option('wpc_permissions_folders', $_POST['wpc_permissions_folders']);   
            break;
        case 'wpc_fgc':
            update_option('wpc_fgc', $_POST['wpc_fgc']);
            break;
        case 'reports':
            update_option('wpc_report_email', $_POST['wpc_report_email']);
            update_option('wpc_report_time', $_POST['wpc_report_time']);
            
            if ( isset($_POST['sendnow']) && ($_POST['sendnow'] == 1) ) {
                wpc_reports(1);
            }
            break;
        default: break;
    }
}

$EndDate = mktime(23, 59, 59, date('m'), date('d'), date('Y')); 
$StartDate = $EndDate - 14*24*3600 + 1;                          

?>

<script language="javascript" src="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../js/jquery.js"></script>
<script language="javascript" src="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../js/ui.datepicker.js"></script>

<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/ui.all.css" />
<style>

.ui-state-highlight {
      background: inerhit;
}      

select {
    width: 100px;
    height: 150px;
}

.filter_heading {
    width: 500px; height: 25px; background: #fafafa; border: 1px #ddd solid; text-align: left; cursor: hand; cursor: pointer;
}

hr {
    margin: 10px 30px 20px;
    background: transparent;
    border-top: transparent;
    border-left: transparent;
    border-right: transparent;
    border-bottom: 1px dashed #888;
}  

</style>

<script language="javascript">

var Today = '<?=date('Y-m-d', time())?>'; 

var StartDate = '<?=date('Y-m-d', $StartDate)?>';
var EndDate = '<?=date('Y-m-d', $EndDate)?>';
        
$(document).ready(function() {            
            
    var T = Today.split('-');
    var Now = new Date(T[0], T[1]-1, T[2]);
    
    var ST = StartDate.split('-');
    var Start = new Date(ST[0], ST[1] - 1, ST[2]);
    
    dif = parseInt( (Now.getTime() - Start.getTime()) / (1000 * 3600 * 24) );
                   
    $("#startdate").datepicker({
        dateFormat: 'yy-mm-dd',
        defaultDate: '-' + dif + 'd',
        maxDate: 0,
        gotoCurrent: true, 
        currentText: 'Current', 
        onSelect: function(dateText) { 
            StartDate = dateText;                                                                                                  
        }     
    });
    $("#startdate").val(StartDate);
    
    var EN = EndDate.split('-');
    var End = new Date(EN[0], EN[1] - 1, EN[2]);
    
    dif = parseInt( (Now.getTime() - End.getTime()) / (1000 * 3600 * 24) );
              
    $("#enddate").datepicker({
        dateFormat: 'yy-mm-dd',
        defaultDate: '-' + dif + 'd',
        maxDate: 0,
        gotoCurrent: true, 
        currentText: 'Current',
        onSelect: function(dateText) { 
            EndDate = dateText;                                                                                                    
        } 
    });
    $("#enddate").val(EndDate);
    
});


function Togle(id) {
    var my = document.getElementById(id);
    
    if (my.style.display == 'none') {
        $(my).slideDown();
    } else {
        $(my).slideUp();
    }
}
                                  
var TrafficType = 'search';
                                
function ShowHide(id) {
    if ($('#'+id).get(0).style.display == 'none') { $('#'+id).slideDown(); } else { $('#'+id).slideUp(); }
}
             

</script>          

<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/listbox.css" />

<?
if (isset($_GET['display-report'])) {
    $content = @file_get_contents($plugin_abs.'/tracker/reports/'.$_GET['display-report'].'.html');
    
    if (!empty($content)) {
        print $content;
    } else {
        print 'Report Not Available. Please Check Your Settings';
    }
    
} else {
?>

<div id="listbox">
    <div id="listbox-title"><font>Other Settings</font></div>
    <div id="listbox-mid">
            <?=isset($_POST['op']) ? '<div style="width: 100%; height: 30px;"><div style="float: left; width: 600px; margin-left: 30px; color: red;"><br />Settings Saved Successfully</div></div>' : ''?>      
            
            <script language="javascript">
            function Check1() {
                if (document.getElementById('wpc_report_email').value == '') {
                    alert('You must enter an email address to receive a report.');
                    document.getElementById('wpc_report_email').focus();
                    return false;
                }
                
                if (document.getElementById('sendnow').value == '1') {
                    alert('Check your email for the Site Usage Report!');
                }
                return true;
            }
            </script>
            
            <form method="post" action="" onsubmit="javascript: return Check1();">
            <input type="hidden" name="op" value="reports">  
            <input type="hidden" name="sendnow" id="sendnow" value="0">  
            <div style="width: 100%;">
                <div style="width: 750px; margin-left: 30px;">       
                    <br />
                    
                    Email Site Usage Reports:
                    <br />                                    
                    <table cellpadding="0" cellspacing="0" width="100%">
                        <tr> 
                            <td valign="top" align="left">Email Address: </td>
                            <td valign="top" align="left" style="padding-left: 5px;"><input type="text" name="wpc_report_email" id="wpc_report_email" value="<?=get_option('wpc_report_email')?>" /></td>
                            
                            <td valign="top" align="left" style="padding-left: 5px;">Send Reports: </td>
                            <td valign="top" align="left" style="padding-left: 5px;">
                                <select name="wpc_report_time">
                                    <option value="0"  <?=(get_option('wpc_report_time') == '0')  ? 'selected' : ''?>>Never</option>
                                    <option value="7"  <?=(get_option('wpc_report_time') == '7')  ? 'selected' : ''?>>Weekly</option>
                                    <option value="14" <?=(get_option('wpc_report_time') == '14') ? 'selected' : ''?>>Bi-Weekly</option>
                                    <option value="30" <?=(get_option('wpc_report_time') == '30') ? 'selected' : ''?>>Monthly</option>
                                </select>
                            </td>
                            <td valign="middle" align="left" style="padding-left: 5px;">
                                <input type="submit" value="Update Reports Settings">
                            </td>
                            <td valign="middle" align="left" style="padding-left: 5px;">
                                <input type="submit" value="Generate a Report Now" onclick="javascript: document.getElementById('sendnow').value = '1'; ">
                            </td>
                        </tr>
                    </table>
                            
                    <br />
                    <small>
                    Please provide a valid email address. If you don't want reports to be emailed to you, select "Never" from the drop-down menu.
                    </small>
                </div>
            </div>

            <br />   
            </form>
        
            
            <form method="post" action="" onsubmit="if (!window.confirm('Are you sure?')) {return false;}">
            <input type="hidden" name="op" value="delete">

            <div style="width: 100%; height: 30px;">
                <div style="float: left; width: 600px; margin-left: 30px;">
                    Delete previous data from
                    <input type="text" name="startdate" id="startdate"> to <input type="text" name="enddate" id="enddate">
                    <input type="submit" value="Delete Now">
                </div>
            </div>

            <br />   
            </form>

            <div style="width: 100%; height: 30px;">
                <div style="float: left; width: 600px; margin-left: 30px;">
                    Automatically Delete previous data: 
                    <select name="DropDownAutoClean" id="DropDownAutoClean" style="width: 200px;" onchange="window.location = '<?=get_option('home')?>/?change-autoclean='+this.options[this.selectedIndex].value;">
                        <option value="0" <?= (get_option('wpc_clean') == '0') ? 'selected' : '' ?>>Keep Everything (disable feature)</option>      
                        <option value="1" <?= (get_option('wpc_clean') == '1') ? 'selected' : '' ?>>Older than 1 day</option>      
                        <option value="3" <?= (get_option('wpc_clean') == '3') ? 'selected' : '' ?>>Older than 3 days</option>      
                        <option value="7" <?= (get_option('wpc_clean') == '7') ? 'selected' : '' ?>>Older than 1 week</option>      
                        <option value="14" <?= (get_option('wpc_clean') == '14') ? 'selected' : '' ?>>Older than 2 weeks</option>      
                        <option value="30" <?= (get_option('wpc_clean') == '30') ? 'selected' : '' ?>>Older than 1 month</option>      
                        <option value="60" <?= (get_option('wpc_clean') == '60') ? 'selected' : '' ?>>Older than 2 months</option>      
                        <option value="90" <?= (get_option('wpc_clean') == '90') ? 'selected' : '' ?>>Older than 3 months</option>      
                        <option value="180" <?= (get_option('wpc_clean') == '180') ? 'selected' : '' ?>>Older than 6 months</option>      
                        <option value="365" <?= (get_option('wpc_clean') == '365') ? 'selected' : '' ?>>Older than 12 months</option>      
                    </select>
                </div>
            </div> 
            
            <br />
            
            <div style="width: 100%; height: 30px;">
                <div style="float: left; width: 600px; text-align: left; margin-left: 30px;">
                    Enable / Disable Tracking on <a href="<?=get_option('home')?>/wp-admin/edit.php">posts</a> or 
                    <a href="<?=get_option('home')?>/wp-admin/edit.php?post_type=page">pages</a>.
                </div>
            </div>
            
            <br />
            
            <div style="width: 100%; height: 30px;">
                <div style="float: left; width: 600px; margin-left: 30px;">
                    Select Your Timezone: 
                    <select name="DropDownTimezone" id="DropDownTimezone" style="width: 400px;" onchange="window.location = '<?=get_option('home')?>/?change-timezone='+this.options[this.selectedIndex].value;">
                          <option value="-12.0" <?= (get_option('wpc_timezone') == '-12.0') ? 'selected' : '' ?>>(GMT -12:00) Eniwetok, Kwajalein</option>
                          <option value="-11.0" <?= (get_option('wpc_timezone') == '-11.0') ? 'selected' : '' ?>>(GMT -11:00) Midway Island, Samoa</option>
                          <option value="-10.0" <?= (get_option('wpc_timezone') == '-10.0') ? 'selected' : '' ?>>(GMT -10:00) Hawaii</option>
                          <option value="-9.0" <?= (get_option('wpc_timezone') == '-9.0') ? 'selected' : '' ?>>(GMT -9:00) Alaska</option>
                          <option value="-8.0" <?= (get_option('wpc_timezone') == '-8.0') ? 'selected' : '' ?>>(GMT -8:00) Pacific Time (US &amp; Canada)</option>
                          <option value="-7.0" <?= (get_option('wpc_timezone') == '-7.0') ? 'selected' : '' ?>>(GMT -7:00) Mountain Time (US &amp; Canada)</option>
                          <option value="-6.0" <?= (get_option('wpc_timezone') == '-6.0') ? 'selected' : '' ?>>(GMT -6:00) Central Time (US &amp; Canada), Mexico City</option>
                          <option value="-5.0" <?= (get_option('wpc_timezone') == '-5.0') ? 'selected' : '' ?>>(GMT -5:00) Eastern Time (US &amp; Canada), Bogota, Lima</option>
                          <option value="-4.0" <?= (get_option('wpc_timezone') == '-4.0') ? 'selected' : '' ?>>(GMT -4:00) Atlantic Time (Canada), Caracas, La Paz</option>
                          <option value="-3.5" <?= (get_option('wpc_timezone') == '-3.5') ? 'selected' : '' ?>>(GMT -3:30) Newfoundland</option>
                          <option value="-3.0" <?= (get_option('wpc_timezone') == '-3.0') ? 'selected' : '' ?>>(GMT -3:00) Brazil, Buenos Aires, Georgetown</option>
                          <option value="-2.0" <?= (get_option('wpc_timezone') == '-2.0') ? 'selected' : '' ?>>(GMT -2:00) Mid-Atlantic</option>
                          <option value="-1.0" <?= (get_option('wpc_timezone') == '-1.0') ? 'selected' : '' ?>>(GMT -1:00 hour) Azores, Cape Verde Islands</option>
                          <option value="0.0" <?= (get_option('wpc_timezone') == '0.0') ? 'selected' : '' ?>>(GMT) Western Europe Time, London, Lisbon, Casablanca</option>
                          <option value="1.0" <?= (get_option('wpc_timezone') == '1.0') ? 'selected' : '' ?>>(GMT +1:00 hour) Brussels, Copenhagen, Madrid, Paris</option>
                          <option value="2.0" <?= (get_option('wpc_timezone') == '2.0') ? 'selected' : '' ?>>(GMT +2:00) Kaliningrad, South Africa</option>
                          <option value="3.0" <?= (get_option('wpc_timezone') == '3.0') ? 'selected' : '' ?>>(GMT +3:00) Baghdad, Riyadh, Moscow, St. Petersburg</option>
                          <option value="3.5" <?= (get_option('wpc_timezone') == '3.5') ? 'selected' : '' ?>>(GMT +3:30) Tehran</option>
                          <option value="4.0" <?= (get_option('wpc_timezone') == '4.0') ? 'selected' : '' ?>>(GMT +4:00) Abu Dhabi, Muscat, Baku, Tbilisi</option>
                          <option value="4.5" <?= (get_option('wpc_timezone') == '4.5') ? 'selected' : '' ?>>(GMT +4:30) Kabul</option>
                          <option value="5.0" <?= (get_option('wpc_timezone') == '5.0') ? 'selected' : '' ?>>(GMT +5:00) Ekaterinburg, Islamabad, Karachi, Tashkent</option>
                          <option value="5.5" <?= (get_option('wpc_timezone') == '5.5') ? 'selected' : '' ?>>(GMT +5:30) Bombay, Calcutta, Madras, New Delhi</option>
                          <option value="5.75" <?= (get_option('wpc_timezone') == '5.75') ? 'selected' : '' ?>>(GMT +5:45) Kathmandu</option>
                          <option value="6.0" <?= (get_option('wpc_timezone') == '6.0') ? 'selected' : '' ?>>(GMT +6:00) Almaty, Dhaka, Colombo</option>
                          <option value="7.0" <?= (get_option('wpc_timezone') == '7.0') ? 'selected' : '' ?>>(GMT +7:00) Bangkok, Hanoi, Jakarta</option>
                          <option value="8.0" <?= (get_option('wpc_timezone') == '8.0') ? 'selected' : '' ?>>(GMT +8:00) Beijing, Perth, Singapore, Hong Kong</option>
                          <option value="9.0" <?= (get_option('wpc_timezone') == '9.0') ? 'selected' : '' ?>>(GMT +9:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk</option>
                          <option value="9.5" <?= (get_option('wpc_timezone') == '9.5') ? 'selected' : '' ?>>(GMT +9:30) Adelaide, Darwin</option>
                          <option value="10.0" <?= (get_option('wpc_timezone') == '10.0') ? 'selected' : '' ?>>(GMT +10:00) Eastern Australia, Guam, Vladivostok</option>
                          <option value="11.0" <?= (get_option('wpc_timezone') == '11.0') ? 'selected' : '' ?>>(GMT +11:00) Magadan, Solomon Islands, New Caledonia</option>
                          <option value="12.0" <?= (get_option('wpc_timezone') == '12.0') ? 'selected' : '' ?>>(GMT +12:00) Auckland, Wellington, Fiji, Kamchatka</option>
                    </select>
                </div>
            </div>    
            
            
            
                      
            
            <form method="post" action="">
            <input type="hidden" name="op" value="ips">

            <?
            $ips = get_option('wpc_blocked_ips');
            
            $ips = explode("\n", $ips); 
            
            $trackingme = 1;
            
            if (in_array($_SERVER['REMOTE_ADDR'], $ips)) {
                $trackingme = 0;
            }
            ?>
            <div style="width: 100%;">
                <div style="width: 600px; margin-left: 30px;">
                    <br />
                    
                    Block WPClicks from tracking these IPs (one on each row):
                    <br />
                    <i><?=($trackingme == 1) ? 'WPClicks is tracking your IP too.' : 'WPClicks will not track your browser while visiting your own site because your IP is in the list'?></i>
                    <br />
                    <textarea style="width: 400px; height: 150px;" name="wpc_blocked_ips"><?=get_option('wpc_blocked_ips')?></textarea>
                    <br />
                    <input type="submit" value="Update List">
                    
                    <br />
                    <br />
                    <small>
                    You can enter specific IP addresses here, one per line.  Or if you want to block multiple IPs that follow the same pattern, you can do that as well.
                    ie. 10.*.*.* will match every IP starting with 10. while 10.*.*.200 will match every IP starting with 10 and ending with 200.

                    You must use IPv4 IP addresses (e.g. 1.2.3.4) and you must have 4 numbers inside.  10.* won't do it, it must be 10.*.*.*
                    </small>
                </div>
            </div>

            <br />   
            </form>
        
        
        <br />
        <br />     

    </div>
    <div id="listbox-bottom"></div>
</div>

<div id="listbox">
    <div id="listbox-title"><font>Advanced Users Only!</font></div>
    <div id="listbox-mid">
        
        <br />
        <br />
        
        <div style="width: 100%; height: 30px;">
            <div style="float: left; width: 600px; margin-left: 30px;">
                WPClicks Automatic Updating: 
                
                <select name="WPCAutoUpdate" id="WPCAutoUpdate" style="width: 200px;" onchange="window.location = '<?=get_option('home')?>/?change-autoupdate='+this.options[this.selectedIndex].value;">
                    <option value="ALL" <?=($wpc_auto_update == 'ALL') ? 'selected' : ''?> >All Updates</option>      
                    <option value="IMPORTANT" <?=($wpc_auto_update == 'IMPORTANT') ? 'selected' : ''?> >Only Important Updates</option>      
                    <option value="NONE" <?=($wpc_auto_update == 'NONE') ? 'selected' : ''?> >No Automatic Updates</option>      
                </select>
                
                <div style="float: right; width: 200px; <?=(get_option('wpc_auto_update') == 'NONE') ? ('display: block;') : ('display: none;') ?>"><a href="<?=get_option('home')?>/?do-autoupdate">Update Now</a></div>
            </div>
        </div>
        
        <hr />     
        
        <a href="javascript: ShowHide('advanced-div');" style="margin-left: 30px; line-height: 30px;">Advanced Permissions Settings</a>
        
        <form method="post" action="">
            <input type="hidden" name="op" value="permissions">

            <?
            
            $permissions_overwrite = get_option('wpc_permissions_overwrite');
            $permissions_files = get_option('wpc_permissions_files');
            $permissions_folders = get_option('wpc_permissions_folders');
              
            ?>
            <div style="width: 100%; display: none;" id="advanced-div">
                <div style="width: 600px; margin-left: 30px;">    
                    
                    <small><i>By default, WPClicks uses your server's default settings for files/folders permissions. However, 
                    in rare cases a user's default server permission settings can cause issues with WPClicks, preventing it from 
                    tracking properly.</i></small>
                    
                    <br />
                    <br />
                    <small><i>
                    We do offer you the possibility to change those default settings only for WPClicks's environment though, 
                    which means all files/folders created by WPClicks on your server ( /tracker/cache/ folder only) 
                    will have these permissions. Default recommended setting is 0644 for files and 0755 for folders (which runs fine on 
                    most common server configurations). 
                    If you think you know what you're doing, you can change that to your preferred values below. 
                    <b>DO NOT edit this unless you know what you're doing.</b>
                    </i></small> 
                    
                    <br />   
                    <br /> 
                      
                    <input type="checkbox" name="wpc_permissions_overwrite" <?= ($permissions_overwrite == 1) ? 'checked' : ''?> />
                    Overwrite default settings. 
                    <br />
                    <br />
                    <table>
                        <tr>
                            <td rowspan="2" valign="middle">
                                
                            </td>
                            <td valign="top" align="left">Files Permissions:</td>
                            <td valign="top" align="left"><input type="text" name="wpc_permissions_files" value="<?=$permissions_files?>"></td>
                            <td rowspan="2" valign="middle">
                                <input type="submit" value="Update Permissions Settings">
                            </td>
                        </tr>
                        
                        <tr>
                            <td valign="top" align="left">Folders Permissions:</td>
                            <td valign="top" align="left"><input type="text" name="wpc_permissions_folders" value="<?=$permissions_folders?>"></td>
                        </tr>
                    </table>    

                    <br />
                    
                </div>
            </div>

            <br />   
        </form>    
        
        <a href="javascript: ShowHide('fgc-div');" style="margin-left: 30px; line-height: 30px;">Recording and Caching Settings</a>
        
        <form method="post" action="">
            <input type="hidden" name="op" value="wpc_fgc">

            <?
            
            $wpc_fgc = get_option('wpc_fgc');                            
              
            ?>
            <div style="width: 100%; display: none;" id="fgc-div">
                <div style="width: 600px; margin-left: 30px;">    
                    
                    <small><i>By default, WPClicks uses "file_get_contents" help grab the contents of the recordings. However, 
                    some servers have that function disabled in their configuration, which causes WPClicks to stop working. 
                    If this is the case for you, you should change the setting below to "cURL", which will (most likely) solve 
                    the problem.</i></small>
                    
                    <br />
                    <br />
                    <small><i>
                    <b>We strongly advise that you NOT change anything here unless you have to. </b>
                    </i></small> 
                    
                    <br />   
                    <br />    
                    <table>
                        <tr>      
                            <td valign="top" align="left">Page Caching Method:</td>
                            <td valign="top" align="left">
                                <select name="wpc_fgc" style="width: 200px;">
                                    <option value="file_get_contents" <?= ($wpc_fgc == 'file_get_contents') ? 'selected' : '' ?>>File_get_contents (default)</option>
                                    <option value="curl" <?= ($wpc_fgc == 'curl') ? 'selected' : '' ?>>cURL</option>
                                </select>
                            </td>
                            <td rowspan="2" valign="middle">
                                <input type="submit" value="Update Settings">
                            </td>
                        </tr>       
                    </table>    

                    <br />
                    
                </div>
            </div>

            <br />   
        </form>
        
        
    </div>
    <div id="listbox-bottom"></div>
</div>

<? } ?>





            
