<?php 
    if (isset($_GET['track'])) {
        include '../tracker/lib/js.php';
        exit;
    } 
    
    if (isset($_GET['env'])) {
        include '../tracker/lib/env.php';
        exit;
    } 
    
    if (isset($_GET['store'])) {
        include '../tracker/lib/store.php'; 
        
        exit;
    }
    
    if (isset($_GET['play'])) {
        if (is_user_logged_in() !== false) {
            include 'player.php';
            exit;
        } else {
            header('Location: '.get_option('home')); exit;
        }
    }
    
    if (isset($_GET['player-data'])) {
        include 'player.data.php';
        exit;
    }
    
    if (isset($_GET['cache-content'])) {
        include 'get.cache.php';
        exit;
    }
    
    if (isset($_GET['change-filter'])) {
        $filters = @unserialize(@stripslashes(get_option('wpc_filters')));             
        
        $filters[$_GET['filter']] = $_GET['val'];
        
        update_option('wpc_filters', addslashes(serialize($filters)));   
        update_option('wpc_filters_expire', (time()+$filters_expire));   
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page='.$_GET['ret']);
    
        exit;
    }
    
    if (isset($_GET['change-date'])) {
        if ($_GET['end_date'] > $_GET['start_date']) {
            setcookie('start_date', $_GET['start_date'], time() + $filters_expire);    
            setcookie('end_date', $_GET['end_date'], time() + $filters_expire);        
        } else {
            setcookie('start_date', $_GET['end_date'], time() + $filters_expire);    
            setcookie('end_date', $_GET['start_date'], time() + $filters_expire);    
        }
        
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page='.$_GET['ret']);
        
        exit;
    }
    
    if (isset($_GET['sessiondetails'])) {
        include 'session.details.php';
        exit;
    }
    
    if (isset($_GET['sessiondetails2'])) {
        include 'session.details.2.php';
        exit;
    }
    
    if (isset($_GET['change-timezone'])) {  
                       
        update_option('wpc_timezone', $_GET['change-timezone']);
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page=wpc-other-options');
    
        exit;
    }
    
    if (isset($_GET['change-autoclean'])) {  
                       
        update_option('wpc_clean', $_GET['change-autoclean']);
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page=wpc-other-options');
    
        exit;
    }
    
    if (isset($_GET['enable-tracking'])) {
        if (get_option('wpc_enabled') == '1') {
            update_option('wpc_enabled', '0');
        } else {
            update_option('wpc_enabled', '1');
        }
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page='.$_GET['p']);
        exit;
    }
    
    if (isset($_GET['deactivate'])) {
        if ($_GET['key'] == get_option('wpc_code')) {
            wpc_uninstall();        
        }
    }
    
    
    if (isset($_GET['change-autoupdate'])) {  
                       
        update_option('wpc_auto_update', $_GET['change-autoupdate']);
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page=wpc-other-options');
    
        exit;
    } 
    
    if (isset($_GET['do-autoupdate'])) {
        wpc_autoupdate(true);   
        
        header('Location: '.get_option('home').'/wp-admin/admin.php?page=wpc-other-options');
    
        exit;  
    }
    
?>