<?
// today's stats
$todaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
$vis = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$todaytime.' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$visuni = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$todaytime.' and 
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');

$act = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$todaytime.' and 
                            p.last_update<'.($todaytime + 3600 * 24 -1).'
                        group by p.ssid;');
                                                     

$today = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$today['conv'] = number_format(($today['visits'] > 0) ? ($today['actions'] * 100 / $today['visits']) : 0, 2).'%' ;



// yesterday
$yesterdaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y')) - 24 * 3600;

$vis = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$yesterdaytime.' and 
                            p.last_update<'.($todaytime-1).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$visuni = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$yesterdaytime.' and 
                            p.last_update<'.($todaytime-1).' and 
                            p.ssid=t.ssid and 
                            t.been_here=0
                        group by t.ssid;');


$act = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$yesterdaytime.' and 
                            p.last_update<'.($todaytime-1).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');                


$yesterday = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$yesterday['conv'] = number_format(($yesterday['visits'] > 0) ? ($yesterday['actions'] * 100 / $yesterday['visits']) : 0, 2).'%' ;

// this week
$days = date('w') - 1;
if ($days == -1) { $days = 6; }

$monday = $todaytime - $days * 24 * 3600;
$sunday = $monday + 7 * 24 * 3600 - 1;

$vis = $wpdb->get_results('select t.ssid  
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$monday.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$visuni = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$monday.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');



$act = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$monday.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).';');          
                               
$thisweek = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$thisweek['conv'] = number_format(($thisweek['visits'] > 0) ? ($thisweek['actions'] * 100 / $thisweek['visits']) : 0, 2).'%' ;  

// last week
$vis = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.($monday - 7 * 24 * 3600).' and 
                            p.last_update<'.($sunday - 7 * 24 * 3600).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$visuni = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.($monday - 7 * 24 * 3600).' and 
                            p.last_update<'.($sunday - 7 * 24 * 3600).' and 
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');


$act = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.($monday - 7 * 24 * 3600).' and 
                            p.last_update<'.($sunday - 7 * 24 * 3600).' and 
                            p.ssid=t.ssid 
                        group by t.ssid

;');
                 
$lastweek = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$lastweek['conv'] = number_format(($lastweek['visits'] > 0) ? ($lastweek['actions'] * 100 / $lastweek['visits']) : 0, 2).'%' ;


// this month
$dayone = mktime(0, 0, 0, date('m'), 1, date('Y'));

$vis = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$dayone.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid
                        group by t.ssid;');


$visuni = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$dayone.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');


$act = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$dayone.' and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$thismonth = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$thismonth['conv'] = number_format(($thismonth['visits'] > 0) ? ($thismonth['actions'] * 100 / $thismonth['visits']) : 0, 2).'%' ;

// last month
$month = date('m');
$year = date('Y');

$lasttime = mktime(0,0,0,$month, 1, $year) - 1;
$month--; if ($month < 0) { $month = 12; $year--;}    

$fisttime = mktime(0,0,0,$month, 1, $year);

$vis = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$fisttime.' and 
                            p.last_update<'.$lasttime.' and 
                            p.ssid=t.ssid
                        group by t.ssid;');

$visuni = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$fisttime.' and 
                            p.last_update<'.$lasttime.' and 
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');

$act = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>'.$fisttime.' and 
                            p.last_update<'.$lasttime.' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');

$lastmonth = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$lastmonth['conv'] = number_format(($lastmonth['visits'] > 0) ? ($lastmonth['actions'] * 100 / $lastmonth['visits']) : 0, 2).'%' ;


$vis = $wpdb->get_results('select t.ssid
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and
                            p.ssid=t.ssid 
                        group by t.ssid;');
                        
$visuni = $wpdb->get_results('select t.ssid 
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and
                            p.ssid=t.ssid and 
                            t.been_here=0 
                        group by t.ssid;');

$act = $wpdb->get_results('select t.ssid  
                        from 
                            tr_pages p, tr_visits t 
                        where 
                            p.gid like "%'.$_GET['stats'].'%" and 
                            p.sale like "%'.$_GET['stats'].'%" and 
                            p.last_update>0 and
                            p.last_update<'.($todaytime + 3600 * 24 - 1).' and 
                            p.ssid=t.ssid 
                        group by t.ssid;');
                      
$overall = array(
    'visits'    =>  count($vis), 
    'uniques'   =>  count($visuni), 
    'actions'   =>  count($act)
);
$overall['conv'] = number_format(($overall['visits'] > 0) ? ($overall['actions'] * 100 / $overall['visits']) : 0, 2).'%' ;
    
?>

<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/listbox.css" />

<script language="javascript">

function NoActions() {
    alert('There are currently no actions to view for the date selected!');
}

</script>

<div id="listbox">
        <div id="listbox-title"><div style="background: url('<?=$plugin_url?>/img/list/stats-icon.png') center left no-repeat;">Stats</div></div>
        <div id="listbox-mid">
            <table width="818" cellpadding="0" cellspacing="0" style="margin-left: 1px;">
                <tr>                         
                    <td valign="top" align="left" class="list title"></td>
                    <td valign="top" align="center" class="list title bordered">Visits</td>
                    <td valign="top" align="center" class="list title bordered">Uniques</td>
                    <td valign="top" align="center" class="list title bordered">Actions</td>
                    <td valign="top" align="center" class="list title bordered">Conversion Rate</td>
                    <td valign="top" align="center" class="list title bordered"></td>
                </tr>          
                
                <tr>
                    <td valign="top" align="left" class="list row1">Today</td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$today['visits']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$today['uniques']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$today['actions']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$today['conv']?></td>
                    <td valign="top" align="center" class="list row1 bordered">
                        <?= ($today['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=today&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                              
                </tr>
                
                <tr>
                    <td valign="top" align="left" class="list row2">Yesterday</td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$yesterday['visits']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$yesterday['uniques']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$yesterday['actions']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$yesterday['conv']?></td> 
                    <td valign="top" align="center" class="list row2 bordered">
                        <?= ($yesterday['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=yesterday&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                              
                </tr>
                
                <tr>
                    <td valign="top" align="left" class="list row1">This Week</td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thisweek['visits']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thisweek['uniques']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thisweek['actions']?></td> 
                    <td valign="top" align="center" class="list row1 bordered"><?=$thisweek['conv']?></td> 
                    <td valign="top" align="center" class="list row1 bordered">
                        <?= ($thisweek['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=thisweek&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                               
                </tr>
                
                <tr>
                    <td valign="top" align="left" class="list row2">Last Week</td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastweek['visits']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastweek['uniques']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastweek['actions']?></td>   
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastweek['conv']?></td>   
                    <td valign="top" align="center" class="list row2 bordered">
                        <?= ($lastweek['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=lastweek&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                                
                </tr>
                
                <tr>
                    <td valign="top" align="left" class="list row1">This Month</td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thismonth['visits']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thismonth['uniques']?></td>
                    <td valign="top" align="center" class="list row1 bordered"><?=$thismonth['actions']?></td>       
                    <td valign="top" align="center" class="list row1 bordered"><?=$thismonth['conv']?></td>       
                    <td valign="top" align="center" class="list row1 bordered">
                        <?= ($thismonth['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=thismonth&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                                
                </tr>
                
                <tr>
                    <td valign="top" align="left" class="list row2">Last Month</td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastmonth['visits']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastmonth['uniques']?></td>
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastmonth['actions']?></td>    
                    <td valign="top" align="center" class="list row2 bordered"><?=$lastmonth['conv']?></td>    
                    <td valign="top" align="center" class="list row2 bordered">
                        <?= ($lastmonth['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=lastmonth&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                                
                </tr>       
                
                <tr>
                    <td valign="top" align="left" class="list row1"><b>All Time</b></td>
                    <td valign="top" align="center" class="list row1 bordered"><b><?=$overall['visits']?></b></td>
                    <td valign="top" align="center" class="list row1 bordered"><b><?=$overall['uniques']?></b></td>
                    <td valign="top" align="center" class="list row1 bordered"><b><?=$overall['actions']?></b></td>      
                    <td valign="top" align="center" class="list row1 bordered"><b><?=$overall['conv']?></b></td>      
                    <td valign="top" align="center" class="list row1 bordered">
                        <?= ($overall['conv'] != '0.00%') ? '<a href="admin.php?page=wpc-visitors&g='.$_GET['stats'].'&d=overall&a=1">View Actions</a>' : '<a href="javascript: NoActions();">View Actions</a>' ?>
                    </td>                                                               
                </tr>
             </table>

        </div>
        <div id="listbox-bottom"></div>
    </div>

