<script language="javascript" src="<?=$plugin_url?>/js/jquery.js"></script>
<script language="javascript" src="<?=$plugin_url?>/js/jquery.blockUI.js"></script>
<script language="javascript" src="<?=$plugin_url?>/js/jquery.corner.js"></script>

<script language="javascript">

function OpenVideo() {
    $.blockUI({
        message: $('#demo-video'),
        fadeIn: 200,
        fadeOut: 200,
        css: {
            border: 'none',     
            background: 'none',     
            top: ( $(window).height() - $('#demo-video').height() ) / 2 + "px",
            left: ( $(window).width() - $('#demo-video').width() ) / 2+$(window).scrollLeft() + "px", 
            padding: '0px',
            opacity: .99,
            cursor: null,
            color: '#fff'
        }
    });
    
    $('#demo-video').corner();
    $('#demo-video-content').corner();

}

function CloseVideo() {
    $.unblockUI();
}

</script>

<style>

#demo-video {
    width: 680px;   
    background: #000;
    padding: 5px;
}

#demo-video-content {
    background: #fafafa;
    padding: 20px 10px;      
}

</style>

<link rel="stylesheet" type="text/css" media="screen" href="<?=$plugin_url?>/css/general-settings.css" />    
     
    
<div id="box">
    <div id="box-head">
        <span>Dashboard (v<?=$wpc_version?>)</span>
        
        <a href="javascript: OpenVideo();" style="float: right; margin:  5px 20px 0px;"><img src="<?=$plugin_url?>/img/watch-this.png" border="0" /></a>
        
        <div style="clear: both;"></div>
    </div>
    <div id="box-mid">
        <div id="box-mid-content"> 
            <?
            $wpc_sctf = trim(get_option('wpc_sctf'));
            if ($wpc_sctf != '') {
                ?>
                <br />
                <br />
                
                <center><font color="red"><b><i><?=base64_decode($wpc_sctf)?></i></b></font></center>
                
                <br />
                <br />
                <?
            }
            ?>    
            <table class="form-table" cellpadding="0" cellspacing="0" border="0">

                <tr>
                    <td valign="top" align="left" width="40">
                        <img src="<?=$plugin_url?>/img/home-page/watch-visitors-icon.png" border="0" />
                    </td>
                    <td valign="top" align="left">
                        <a href="admin.php?page=wpc-visitors" style="font-family: Georgia; font-size: 22px; color: #0362b7; font-weight: normal; text-decoration: underline;">Watch Visitors</a>
                           
                        
                        <br /> 
                        <br />
                        
                        This is the main hub for viewing your stats and watching all of the visitor videos. Watch live, real-time 
                        recordings of your visitors interacting with your site.      

                        Filter videos based on visitor settings such as referred traffic, search engine traffic, computer profiles, goal 
                        campaigns, and more.
                    </td>  
                </tr>
                
                <tr>
                    <td valign="top" align="left" width="40">
                        <img src="<?=$plugin_url?>/img/home-page/goals-icon.png" border="0" />
                    </td>
                    <td valign="top" align="left">
                        <a href="admin.php?page=wpc-campaigns" style="font-family: Georgia; font-size: 22px; color: #0362b7; font-weight: normal; text-decoration: underline;">Goal Campaigns</a>
                           
                        
                        <br />
                        <br />
                        
                        Create and Track Goal Campaigns following your visitor from his arrival onto your site through to the 
                        moment he signs up or buys.
                    </td>  
                </tr>
                
                <tr>
                    <td valign="top" align="left" width="40">
                        <img src="<?=$plugin_url?>/img/home-page/search-stats-icon.png" border="0" />
                    </td>
                    <td valign="top" align="left">
                        <a href="admin.php?page=wpc-search" style="font-family: Georgia; font-size: 22px; color: #0362b7; font-weight: normal; text-decoration: underline;">Search Stats</a>
                           
                        
                        <br />
                        <br />
                        
                        This feature shows all of the keyword searches your visitors are performing on your blog.  Know exactly 
                        what they're looking for on your site!  People are searching your blogs for these terms... maybe you 
                        should give them what they want.
                    </td>  
                </tr>
                
                <tr>
                    <td valign="top" align="left" width="40">
                        <img src="<?=$plugin_url?>img/home-page/other-settings-icon.png" border="0" />
                    </td>
                    <td valign="top" align="left">
                        <a href="admin.php?page=wpc-other-options" style="font-family: Georgia; font-size: 22px; color: #0362b7; font-weight: normal; text-decoration: underline;">Other Settings</a>
                        
                        <br />
                        <br />
                        
                        Manage all the other settings here
                    </td>  
                </tr>
                
                <tr>
                    <td valign="top" align="left" width="40">
                        <img src="<?=$plugin_url?>img/home-page/other-settings-icon.png" border="0" />
                    </td>
                    <td valign="top" align="left">
                        <a href="http://www.wpclicks.com/help/" target="_blank" style="font-family: Georgia; font-size: 22px; color: #0362b7; font-weight: normal; text-decoration: underline;">Need Help?</a>
                        
                        <br />
                        <br />
                        
                        WPClicks not working properly?  Before submitting a support ticket, there are a few common issues and 
                        easy fixes that you can perform yourself to quickly resolve the issue.  We have created a step-by-step, 
                        in-depth troubleshooter to help you out with this.
                        <a href="http://www.wpclicks.com/help" target="_blank">Please Try the Troubleshooter Here</a>.
                    </td>  
                </tr>
                             
            </table>
            
            <br />    
            <br />
            
            <font style="color: #888; font-size: 12px;">You're currently running version <?=$wpc_version?>.<?=$wpc_build_no?>.<?=$s?></font>
                        
            <div style="clear: both;"></div>
            
            <br />   
            
        </div>
    </div>
    <div id="box-bottom"></div>
</div>
              

<div id="demo-video" style="display: none;">
    <div id="demo-video-content">
        <embed width="640" height="480" type="application/x-shockwave-flash" src="<?=$plugin_url?>player.swf" style="" id="demovideo" name="demovideo" quality="high" allowfullscreen="true"
                allowscriptaccess="always" wmode="opaque" flashvars="file=http://www.wpclicks.com/videos/main_demo.flv&amp;controlbar=over&amp;autostart=true">
        <br />
        <a href="javascript: CloseVideo();" style="float: right;"><img src="<?=$plugin_url?>/img/close.png" border="0" style="margin: 10px 10px 0px 0px;" /></a>
        <div style="clear: both;"></div>
    </div>
</div> 
    
    
