<?php

function GetB() {
    
    $UA = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    
    $SF = strstr($UA, 'Safari') ? true : false;
    
    $OP = strstr($UA, 'Opera') ? true : false;
    $OPV = $OP ? preg_split('/opera\//i', $UA) : false;
    $OPV = $OPV ? floatval($OPV[1]) : false;
    
    $FF = !$OP && strstr($UA, 'Firefox') ? true : false;
    $FFV = $FF ? preg_split('/firefox\//i', $UA) : false;
    $FFV = $FFV ? floatval($FFV[1]) : false;
    
    $IE = !$OP && !$FF && strstr($UA, 'MSIE') ? true : false;
    $IEV = $IE ? preg_split('/msie/i', $UA) : false;
    $IEV = $IEV ? floatval($IEV[1]) : false;
    
    if ($IE) {
        return 'Internet Explorer';
    }
    
    if ($FF) {
        return 'Firefox';
    }
    
    if ($OP) {
        return 'Opera';
    }
    
    if ($SF) {
        return 'Safari';
    }
    
}

function GetCountries() {
    return array(
        array('title'=>"AFGHANISTAN", 'mc_name'=>"AF"), 
        array('title'=>"ALAND ISLANDS", 'mc_name'=>"AX"), 
        array('title'=>"ALBANIA", 'mc_name'=>"AL"), 
        array('title'=>"ALGERIA", 'mc_name'=>"DZ"), 
        array('title'=>"ANDORRA", 'mc_name'=>"AD"), 
        array('title'=>"ANGOLA", 'mc_name'=>"AO"), 
        array('title'=>"ANGUILLA", 'mc_name'=>"AI"), 
        array('title'=>"ANTIGUA AND BARBUDA", 'mc_name'=>"AG"), 
        array('title'=>"ARGENTINA", 'mc_name'=>"AR"), 
        array('title'=>"ARMENIA", 'mc_name'=>"AM"), 
        array('title'=>"ARUBA", 'mc_name'=>"AW"), 
        array('title'=>"AUSTRALIA", 'mc_name'=>"AU"), 
        array('title'=>"AUSTRIA", 'mc_name'=>"AT"), 
        array('title'=>"AZERBAIJAN", 'mc_name'=>"AZ"), 
        array('title'=>"BAHAMAS", 'mc_name'=>"BS"), 
        array('title'=>"BAHRAIN", 'mc_name'=>"BH"), 
        array('title'=>"BANGLADESH", 'mc_name'=>"BD"), 
        array('title'=>"BARBADOS", 'mc_name'=>"BB"), 
        array('title'=>"BELARUS", 'mc_name'=>"BY"), 
        array('title'=>"BELGIUM", 'mc_name'=>"BE"), 
        array('title'=>"BELIZE", 'mc_name'=>"BZ"), 
        array('title'=>"BENIN", 'mc_name'=>"BJ"), 
        array('title'=>"BERMUDA", 'mc_name'=>"BM"), 
        array('title'=>"BHUTAN", 'mc_name'=>"BT"), 
        array('title'=>"BOLIVIA", 'mc_name'=>"BO"), 
        array('title'=>"BOSNIA AND HERZEGOVINA", 'mc_name'=>"BA"), 
        array('title'=>"BOTSWANA", 'mc_name'=>"BW"), 
        array('title'=>"BRAZIL", 'mc_name'=>"BR"), 
        array('title'=>"BRUNEI DARUSSALAM", 'mc_name'=>"BN"), 
        array('title'=>"BULGARIA", 'mc_name'=>"BG"), 
        array('title'=>"BURKINA FASO", 'mc_name'=>"BF"), 
        array('title'=>"BURUNDI", 'mc_name'=>"BI"), 
        array('title'=>"CAMBODIA", 'mc_name'=>"KH"), 
        array('title'=>"CAMEROON", 'mc_name'=>"CM"), 
        array('title'=>"CANADA", 'mc_name'=>"CA"), 
        array('title'=>"CAPE VERDE", 'mc_name'=>"CV"), 
        array('title'=>"CENTRAL AFRICAN REPUBLIC", 'mc_name'=>"CF"), 
        array('title'=>"CHAD", 'mc_name'=>"TD"), 
        array('title'=>"CHILE", 'mc_name'=>"CL"), 
        array('title'=>"CHINA", 'mc_name'=>"CN"), 
        array('title'=>"COLOMBIA", 'mc_name'=>"CO"), 
        array('title'=>"COMOROS", 'mc_name'=>"KM"), 
        array('title'=>"REPUBLIC OF CONGO", 'mc_name'=>"CG"), 
        array('title'=>"THE DEMOCRATIC REPUBLIC OF THE CONGO", 'mc_name'=>"CD"), 
        array('title'=>"COSTA RICA", 'mc_name'=>"CR"), 
        array('title'=>"C0TE D'IVOIRE", 'mc_name'=>"CI"), 
        array('title'=>"CROATIA", 'mc_name'=>"HR"), 
        array('title'=>"CUBA", 'mc_name'=>"CU"), 
        array('title'=>"CYPRUS", 'mc_name'=>"CY"), 
        array('title'=>"CZECH REPUBLIC", 'mc_name'=>"CZ"), 
        array('title'=>"DENMARK", 'mc_name'=>"DK"), 
        array('title'=>"DJIBOUTI", 'mc_name'=>"DJ"), 
        array('title'=>"DOMINICA", 'mc_name'=>"DM"), 
        array('title'=>"DOMINICAN REPUBLIC", 'mc_name'=>"DO"), 
        array('title'=>"ECUADOR", 'mc_name'=>"EC"), 
        array('title'=>"EGYPT", 'mc_name'=>"EG"), 
        array('title'=>"EL SALVADOR", 'mc_name'=>"SV"), 
        array('title'=>"EQUATORIAL GUINEA", 'mc_name'=>"GQ"), 
        array('title'=>"ERITREA", 'mc_name'=>"ER"), 
        array('title'=>"ESTONIA", 'mc_name'=>"EE"), 
        array('title'=>"ETHIOPIA", 'mc_name'=>"ET"), 
        array('title'=>"FAEROE ISLANDS", 'mc_name'=>"FO"), 
        array('title'=>"FALKLAND ISLANDS", 'mc_name'=>"FK"), 
        array('title'=>"FIJI", 'mc_name'=>"FJ"), 
        array('title'=>"FINLAND", 'mc_name'=>"FI"), 
        array('title'=>"FRANCE", 'mc_name'=>"FR"), 
        array('title'=>"FRENCH GUIANA", 'mc_name'=>"GF"), 
        array('title'=>"GABON", 'mc_name'=>"GA"), 
        array('title'=>"GAMBIA, THE", 'mc_name'=>"GM"), 
        array('title'=>"GEORGIA", 'mc_name'=>"GE"), 
        array('title'=>"GERMANY", 'mc_name'=>"DE"), 
        array('title'=>"GHANA", 'mc_name'=>"GH"), 
        array('title'=>"GREECE", 'mc_name'=>"GR"), 
        array('title'=>"GREENLAND", 'mc_name'=>"GL"), 
        array('title'=>"GRENADA", 'mc_name'=>"GD"), 
        array('title'=>"GUADELOUPE", 'mc_name'=>"GP"), 
        array('title'=>"GUATEMALA", 'mc_name'=>"GT"), 
        array('title'=>"GUINEA", 'mc_name'=>"GN"), 
        array('title'=>"GUINEA-BISSAU", 'mc_name'=>"GW"), 
        array('title'=>"GUYANA", 'mc_name'=>"GY"), 
        array('title'=>"HAITI", 'mc_name'=>"HT"), 
        array('title'=>"HONDURAS", 'mc_name'=>"HN"), 
        array('title'=>"HONG KONG", 'mc_name'=>"HK"), 
        array('title'=>"HUNGARY", 'mc_name'=>"HU"), 
        array('title'=>"ICELAND", 'mc_name'=>"IS"), 
        array('title'=>"INDIA", 'mc_name'=>"IN"), 
        array('title'=>"INDONESIA", 'mc_name'=>"ID"), 
        array('title'=>"IRAN", 'mc_name'=>"IR"), 
        array('title'=>"IRAQ", 'mc_name'=>"IQ"), 
        array('title'=>"IRELAND", 'mc_name'=>"IE"), 
        array('title'=>"ISRAEL", 'mc_name'=>"IL"), 
        array('title'=>"ITALY", 'mc_name'=>"IT"), 
        array('title'=>"JAMAICA", 'mc_name'=>"JM"), 
        array('title'=>"JAPAN", 'mc_name'=>"JP"), 
        array('title'=>"JORDAN", 'mc_name'=>"JO"), 
        array('title'=>"KAZAKHSTAN", 'mc_name'=>"KZ"), 
        array('title'=>"KENYA", 'mc_name'=>"KE"), 
        array('title'=>"NORTH KOREA", 'mc_name'=>"KP"), 
        array('title'=>"SOUTH KOREA", 'mc_name'=>"KR"), 
        array('title'=>"KUWAIT", 'mc_name'=>"KW"), 
        array('title'=>"KYRGYZSTAN", 'mc_name'=>"KG"), 
        array('title'=>"LAO PEOPLE'S DEMOCRATIC REPUBLIC", 'mc_name'=>"LA"), 
        array('title'=>"LATVIA", 'mc_name'=>"LV"), 
        array('title'=>"LEBANON", 'mc_name'=>"LB"), 
        array('title'=>"LESOTHO", 'mc_name'=>"LS"), 
        array('title'=>"LIBERIA", 'mc_name'=>"LR"), 
        array('title'=>"LIBYA", 'mc_name'=>"LY"), 
        array('title'=>"LIECHTENSTEIN", 'mc_name'=>"LI"), 
        array('title'=>"LITHUANIA", 'mc_name'=>"LT"), 
        array('title'=>"LUXEMBOURG", 'mc_name'=>"LU"), 
        array('title'=>"MACEDONIA", 'mc_name'=>"MK"), 
        array('title'=>"MADAGASCAR", 'mc_name'=>"MG"), 
        array('title'=>"MALAWI", 'mc_name'=>"MW"), 
        array('title'=>"MALAYSIA", 'mc_name'=>"MY"), 
        array('title'=>"MALI", 'mc_name'=>"ML"), 
        array('title'=>"MALTA", 'mc_name'=>"MT"), 
        array('title'=>"MARTINIQUE", 'mc_name'=>"MQ"), 
        array('title'=>"MAURITANIA", 'mc_name'=>"MR"), 
        array('title'=>"MAURITIUS", 'mc_name'=>"MU"), 
        array('title'=>"MEXICO", 'mc_name'=>"MX"), 
        array('title'=>"MOLDOVA", 'mc_name'=>"MD"), 
        array('title'=>"MONGOLIA", 'mc_name'=>"MN"), 
        array('title'=>"MONTENEGRO", 'mc_name'=>"ME"), 
        array('title'=>"MONTSERRAT", 'mc_name'=>"MS"), 
        array('title'=>"MOROCCO", 'mc_name'=>"MA"), 
        array('title'=>"MOZAMBIQUE", 'mc_name'=>"MZ"), 
        array('title'=>"MYANMAR", 'mc_name'=>"MM"), 
        array('title'=>"NAMIBIA", 'mc_name'=>"NA"), 
        array('title'=>"NEPAL", 'mc_name'=>"NP"), 
        array('title'=>"NETHERLANDS", 'mc_name'=>"NL"), 
        array('title'=>"NEW CALEDONIA", 'mc_name'=>"NC"), 
        array('title'=>"NEW ZEALAND", 'mc_name'=>"NZ"), 
        array('title'=>"NICARAGUA", 'mc_name'=>"NI"), 
        array('title'=>"NIGER", 'mc_name'=>"NE"), 
        array('title'=>"NIGERIA", 'mc_name'=>"NG"), 
        array('title'=>"NORWAY", 'mc_name'=>"NO"), 
        array('title'=>"OMAN", 'mc_name'=>"OM"), 
        array('title'=>"PAKISTAN", 'mc_name'=>"PK"), 
        array('title'=>"PALAU", 'mc_name'=>"PW"), 
        array('title'=>"PALESTINIAN TERRITORIES", 'mc_name'=>"PS"), 
        array('title'=>"PANAMA", 'mc_name'=>"PA"), 
        array('title'=>"PAPUA NEW GUINEA", 'mc_name'=>"PG"), 
        array('title'=>"PARAGUAY", 'mc_name'=>"PY"), 
        array('title'=>"PERU", 'mc_name'=>"PE"), 
        array('title'=>"PHILIPPINES", 'mc_name'=>"PH"), 
        array('title'=>"POLAND", 'mc_name'=>"PL"), 
        array('title'=>"PORTUGAL", 'mc_name'=>"PT"), 
        array('title'=>"PUERTO RICO", 'mc_name'=>"PR"), 
        array('title'=>"QATAR", 'mc_name'=>"QA"), 
        array('title'=>"REUNION", 'mc_name'=>"RE"), 
        array('title'=>"ROMANIA", 'mc_name'=>"RO"), 
        array('title'=>"RUSSIAN FEDERATION", 'mc_name'=>"RU"), 
        array('title'=>"RWANDA", 'mc_name'=>"RW"), 
        array('title'=>"SAINT KITTS AND NEVIS", 'mc_name'=>"KN"), 
        array('title'=>"SAINT LUCIA", 'mc_name'=>"LC"), 
        array('title'=>"SAMOA", 'mc_name'=>"WS"), 
        array('title'=>"SAO TOME AND PRINCIPE", 'mc_name'=>"ST"), 
        array('title'=>"SAUDI ARABIA", 'mc_name'=>"SA"), 
        array('title'=>"SENEGAL", 'mc_name'=>"SN"), 
        array('title'=>"SERBIA", 'mc_name'=>"RS"), 
        array('title'=>"SIERRA LEONE", 'mc_name'=>"SL"), 
        array('title'=>"SINGAPORE", 'mc_name'=>"SG"), 
        array('title'=>"SLOVAKIA", 'mc_name'=>"SK"), 
        array('title'=>"SLOVENIA", 'mc_name'=>"SI"), 
        array('title'=>"SOLOMON ISLANDS", 'mc_name'=>"SB"), 
        array('title'=>"SOMALIA", 'mc_name'=>"SO"), 
        array('title'=>"SOUTH AFRICA", 'mc_name'=>"ZA"), 
        array('title'=>"SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS", 'mc_name'=>"GS"), 
        array('title'=>"SPAIN", 'mc_name'=>"ES"), 
        array('title'=>"SRI LANKA", 'mc_name'=>"LK"), 
        array('title'=>"SUDAN", 'mc_name'=>"SD"), 
        array('title'=>"SURINAME", 'mc_name'=>"SR"), 
        array('title'=>"SVALBARD AND JAN MAYEN", 'mc_name'=>"SJ"), 
        array('title'=>"SWAZILAND", 'mc_name'=>"SZ"), 
        array('title'=>"SWEDEN", 'mc_name'=>"SE"), 
        array('title'=>"SWITZERLAND", 'mc_name'=>"CH"), 
        array('title'=>"SYRIAN ARAB REPUBLIC", 'mc_name'=>"SY"), 
        array('title'=>"TAIWAN", 'mc_name'=>"TW"), 
        array('title'=>"TAJIKISTAN", 'mc_name'=>"TJ"), 
        array('title'=>"TANZANIA", 'mc_name'=>"TZ"), 
        array('title'=>"THAILAND", 'mc_name'=>"TH"), 
        array('title'=>"TIMOR-LESTE", 'mc_name'=>"TL"), 
        array('title'=>"TOGO", 'mc_name'=>"TG"), 
        array('title'=>"TONGA", 'mc_name'=>"TO"), 
        array('title'=>"TRINIDAD AND TOBAGO", 'mc_name'=>"TT"), 
        array('title'=>"TUNISIA", 'mc_name'=>"TN"), 
        array('title'=>"TURKEY", 'mc_name'=>"TR"), 
        array('title'=>"TURKMENISTAN", 'mc_name'=>"TM"), 
        array('title'=>"TURKS AND CAICOS ISLANDS", 'mc_name'=>"TC"), 
        array('title'=>"UGANDA", 'mc_name'=>"UG"), 
        array('title'=>"UKRAINE", 'mc_name'=>"UA"), 
        array('title'=>"UNITED ARAB EMIRATES", 'mc_name'=>"AE"), 
        array('title'=>"UNITED KINGDOM", 'mc_name'=>"GB"), 
        array('title'=>"UNITED STATES", 'mc_name'=>"US"), 
        array('title'=>"URUGUAY", 'mc_name'=>"UY"), 
        array('title'=>"UZBEKISTAN", 'mc_name'=>"UZ"), 
        array('title'=>"VANUATU", 'mc_name'=>"VU"), 
        array('title'=>"VENEZUELA", 'mc_name'=>"VE"), 
        array('title'=>"VIET NAM", 'mc_name'=>"VN"), 
        array('title'=>"VIRGIN ISLANDS, BRITISH", 'mc_name'=>"VG"), 
        array('title'=>"WESTERN SAHARA", 'mc_name'=>"EH"), 
        array('title'=>"YEMEN", 'mc_name'=>"YE"), 
        array('title'=>"ZAMBIA", 'mc_name'=>"ZM"), 
        array('title'=>"ZIMBABWE", 'mc_name'=>"ZW")        
    );
}

function FormatTime($time) {
    $time = number_format($time, 0, '', '');
    if ($time > 3600) {
        $rest = $time % 3600;
        $h = ( $time - $rest ) / 3600;
        
        if (strlen($h) == 1) {
            $h = '0'.$h;
        }
        
        $time = $rest;
    } else {
        $h = '00';
    }
    
    
    
    if ($time > 60) {
        $rest = $time % 60;
        $m = ( $time - $rest ) / 60;
        
        if (strlen($m) == 1) {
            $m = '0'.$m;
        }
        
        $time = $rest;
    } else {
        $m = '00';
    }
    
    
    
    $s = $time;
    
    if (strlen($s) == 1) {
        $s = '0'.$s;
    }
    
    return $h.':'.$m.':'.$s;
}

function capitalizeMe($str) {
    $str = strtolower($str);
    $x = explode(' ', $str);
    $str = '';
    
    foreach ($x as $y) {
        $str .= ' '.strtoupper(substr($y, 0, 1)).substr($y, 1);
    }
    
    $str = trim($str);
    
    return $str;
    
}

$countries = GetCountries();

$todaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
$ses = $wpdb->get_results('select * 
                        from 
                            tr_visits  
                        where 
                            tr_visits.ssid="'.$_GET['id'].'"');

$pages = $wpdb->get_results('select * from tr_pages where ssid="'.$_GET['id'].'"');

// get the damn cache
$cache = $wpdb->get_results('select * from tr_cache where cpath="'.$pages[0]->myhost.$pages[0]->mypath.'"');


//if ($ses[0]['pgw'] > 0)
//    $percent = number_format( (( 815 * 100 ) / $ses[0]['pgw']), 0);
//else
//    $percent = 0;

foreach ($countries as $c) {
    if ($ses[0]->country == $c['mc_name']) {
        $ses[0]->country = capitalizeMe($c['title']);
    }
}

$showad = 0;

$browser = GetB();

if ($browser == 'Internet Explorer') {
    include 'play.ff.4.php';    
} else {
    include 'play.ff.4.php';
}
  
?>
