<?php
  
include 'functions.php';
  
$sort = '';
$start = 0;
$older = 0;
$newer = 0;

$ShowPerPage = $filters['spp'];
if ($ShowPerPage == 0) $ShowPerPage = 25;

$ServerOffset = date('Z');
$UserOffset = floatval(get_option('wpc_timezone')) * 3600;

$TotalOffset  = $UserOffset - $ServerOffset + ( (date('I') == 0) ? 3600 : 0);

$TimezoneH = $UserOffset / 3600;
$TimezoneM = ($UserOffset % 3600) / 60;

if ( (-10 < $TimezoneH) && ( $TimezoneH < 0 )  ) $TimezoneH = '-0'.abs($TimezoneH);
if ( (0 < $TimezoneH) && ( $TimezoneH < 10 )  ) $TimezoneH = '0'.abs($TimezoneH);
if ( $TimezoneH == 0 ) $TimezoneH = '00';
if ($TimezoneM < 10) $TimezoneM = '0'.$TimezoneM;


$StartFrom = 0;
$mypage = 1;
if (isset($_GET['start'])) {
    $StartFrom = $_GET['start'];
    $mypage = floor($StartFrom / $ShowPerPage) + 1; 
}

function StartEnd_old() {
    global $total, $StartFrom, $start, $older, $newer;
    
    if (isset($StartFrom)) { 
        $start = $StartFrom;                  
        if ($start > $total) $start = $total - 30;
        if ($start < 0) $start = 0;
    } else $start = 0;
    
    if ($start + 30 < $total) $older = $start + 30; else $older = -1;     
    
    if ($start > 0) $newer = $start - 30; else $newer = -1; 
}

function StartEnd() {
    
}

switch (@$_GET['d']) {
    case 'today':
        // and sale == 1 !!!!!!!!
        
        $todaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid 
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$todaytime.' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        $pages = StartEnd($filters);        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$todaytime.' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
        
        
        break;
    case 'yesterday':
        
        $todaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
        $yesterdaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y')) - 24 * 3600;
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$yesterdaytime.' and 
                                p.last_update<'.$todaytime.' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$yesterdaytime.' and 
                                p.last_update<'.$todaytime.' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
                              
        break;
    case 'thisweek':
        
        $days = date('w') - 1;
        if ($days == -1) { $days = 6; }
        
        $monday = $todaytime - $days * 24 * 3600;
        $sunday = $monday + 7 * 24 * 3600;
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and  
                                p.last_update>'.$monday.' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$monday.' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
            
        break;
    case 'lastweek':
               
        $todaytime = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
        $days = date('w') - 1;
        if ($days == -1) { $days = 6; }
        
        $monday = $todaytime - $days * 24 * 3600;
        $sunday = $monday + 7 * 24 * 3600;
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.($monday - 7 * 24 * 3600).' and 
                                p.last_update<'.($sunday - 7 * 24 * 3600).' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();         
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.($monday - 7 * 24 * 3600).' and 
                                p.last_update<'.($sunday - 7 * 24 * 3600).' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
             
        break;
    case 'thismonth':
        
        $dayone = mktime(0, 0, 0, date('m'), 1, date('Y'));
        
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$dayone.' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$dayone.' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
               
        
        break;
    case 'lastmonth':
        
        $month = date('m');
        $year = date('Y');
        
        $lasttime = mktime(0,0,0,$month, 1, $year) - 1;
        $month--; if ($month < 0) { $month = 12; $year--;}    
    
        $fisttime = mktime(0,0,0,$month, 1, $year);
        
        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$fisttime.' and 
                                p.last_update<'.$lasttime.' and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.last_update>'.$fisttime.' and 
                                p.last_update<'.$lasttime.' and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
        
        
        break;
    case 'overall':
                        
        $totals = $wpdb->get_results('select p.pgid 
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.ssid=t.ssid
                            group by t.ssid '.$sort.' ;');
        $totals = count($totals);
        
//        StartEnd();        
        
        $actions = $wpdb->get_results('select p.pgid, t.*, se.sname, se.searchurl
                            from 
                                tr_pages p, tr_visits t
                            left join tr_sengines se on 
                                t.seid=se.seid
                            where 
                                p.gid like "%'.$_GET['g'].'%" and 
                                p.sale like "%'.$_GET['g'].'%" and 
                                p.ssid=t.ssid 
                            group by t.ssid '.$sort.' 
                            limit '.$StartFrom.', '.$ShowPerPage.';');
        
        
        break;
    default:
        break;
}

$min = 0;
$max = ceil($totals / $ShowPerPage) + 1;

$pages = array();
for ($i = $mypage - 5; $i < $mypage; $i++) {
    if ($i > 0) {
        $newstart = ($i - 1) * $ShowPerPage; if ($newstart < 0) $newstart = 0;
        array_push($pages, array('page' => $i, 'link' => 'admin.php?page=wpc-visitors&g='.$_GET['g'].'&d='.$_GET['d'].'&a=1&start='.$newstart));
    }
}

array_push($pages, array('page' => $mypage, 'link' => ''));

for ($i = $mypage + 1; $i <= $mypage + 5; $i++) {
    if ($i < $max) {
        $newstart = ($i - 1) * $ShowPerPage; 
        
        if ($newstart < 0) $newstart = 0; 
//        if ($newstart > $totals[0][0]) $newstart = $totals[0][0] - $ShowPerPage; 
        
        array_push($pages, array('page' => $i, 'link' => 'admin.php?page=wpc-visitors&g='.$_GET['g'].'&d='.$_GET['d'].'&a=1&start='.$newstart));
    }
}

include 'results.display.php';

?>
