<?php

function Code($minlength = 50, $maxlength = 50, $useupper = true, $usespecial = false, $usenumbers = true) {
    $key = '';
    $charset = "abcdefghijklmnopqrstuvwxyz";
    if ($useupper) $charset .= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    if ($usenumbers) $charset .= "0123456789";
    if ($usespecial) $charset .= "~@#$%^*()_+-={}|]["; // Note: using all special characters this reads: "~!@#$%^&*()_+`-={}|\\]?[\":;'><,./";
    if ($minlength > $maxlength) 
        $length = mt_rand ($maxlength, $minlength);
    else 
        $length = mt_rand ($minlength, $maxlength);
    for ($i = 0; $i < $length; $i++) 
        $key .= $charset[(mt_rand(0,(strlen($charset)-1)))];
    
    return $key;
}

$end_time = time();
$start_time = $end_time - $wpc_report_time * 24 * 3600;    

$allvisits = $wpdb->get_var('select count(ssid) as counter from tr_visits where start_time>"'.$start_time.'" and start_time<"'.$end_time.'";');

ob_start();
?>

    <style>         
    #report-content, td {
        padding-right: 10px;
        margin-left: 30px;
        color: #444;
        font-size: 15px;
        font-family: Arial;
    }
    </style>
    <a href="admin.php?page=wpc-other-options">Back To Admin</a> <br />
    
    <div id="list2">
        <div id="list2-top">
            <font>Site Usage Report for <i><?=date('M dS', $start_time)?></i> to <i><?=date('M dS', $end_time)?></i></font>
        </div> 
        <div id="list2-mid">
                        
        
            <div id="list2-top2" style="margin-top: 0px;"><font>Quick Summary</font></div>
        
            <table width="99%" cellpadding="0" cellspacing="0">  
                <tr>
                    <td valign="top" align="left" width="20" class="list2-td1 list2-bordered">&nbsp;</td>
                    <td valign="top" align="left" class="list2-td1 list2-bordered">Total Visits:</td>
                    <td valign="top" align="left" width="150" class="list2-td1 list2-bordered"><?=$allvisits?></td>
                </tr>

                <?


                $avg = ($wpc_report_time > 0) ? ( number_format($allvisits / $wpc_report_time, 2) ) : 0 ;

                ?>
                <tr>
                    <td valign="top" align="left" class="list2-td2 list2-bordered">&nbsp;</td>
                    <td valign="top" align="left" class="list2-td2 list2-bordered">Avg. Number of Visitors per day:</td>
                    <td valign="top" align="left" class="list2-td2 list2-bordered"><?=$avg?></td>
                </tr>  
                <?

                $avgtime = $wpdb->get_var('select avg(total_time) as avg_time from tr_visits where start_time>"'.$start_time.'" and start_time<"'.$end_time.'";');

                ?>
                <tr>
                    <td valign="top" align="left" width="20" class="list2-td1 list2-bordered">&nbsp;</td>
                    <td valign="top" align="left" class="list2-td1 list2-bordered">Avg. Visitor Time on Site:</td>
                    <td valign="top" align="left" class="list2-td1 list2-bordered"><?=number_format(floatval($avgtime), 2)?> seconds</td>
                </tr>  
            </table>
            
            <div id="list2-top2"><font>Most visited pages</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?

                $pages = $wpdb->get_results('select myhost, mypath, count(pgid) as counter from tr_pages where last_refresh>"'.$start_time.'" and last_refresh<"'.$end_time.'" group by mypath order by counter desc limit 0,5;');
                 
                for ($i = 0; $i < count($pages); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                <tr>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20"><a href="<?=$pages[$i]->myhost.$pages[$i]->mypath?>" target="_blank"><img src="<?=$plugin_url?>/img/watch-visitors/flowchart-row-link.png" border="0" style="margin-top: 5px;" /></a></td>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$pages[$i]->myhost.$pages[$i]->mypath?></td>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=$pages[$i]->counter?> visits</td>
                </tr>
                    <?
                } 

                if (count($pages) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                <? } ?>
            </table>
            
            <div id="list2-top2"><font>Most bounced pages</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?

                $pages = $wpdb->get_results('select myhost, mypath, count(pgid) as counter from tr_pages where isexit=1 and last_refresh>"'.$start_time.'" and last_refresh<"'.$end_time.'" group by mypath order by counter desc limit 0,5;');

                for ($i = 0; $i < count($pages); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                <tr>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20"><a href="<?=$pages[$i]->myhost.$pages[$i]->mypath?>" target="_blank"><img src="<?=$plugin_url?>/img/watch-visitors/flowchart-row-link.png" style="margin-top: 5px;" border="0" /></a></td>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$pages[$i]->myhost.$pages[$i]->mypath?></td>
                    <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=$pages[$i]->counter?> bounces</td>
                </tr>
                    <?
                }

                if (count($pages) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <? } ?>
            </table>
            
            <div id="list2-top2"><font>Pages Visited for Longest Avg Time</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $pages = $wpdb->get_results('select myhost, mypath, count(pgid) as counter, avg(total_time) as avg_time 
                                                            from tr_pages 
                                                            where 
                                                                    last_refresh>"'.$start_time.'" 
                                                                and last_refresh<"'.$end_time.'" 
                                                            group by mypath order by avg_time desc limit 0,5;');

                for ($i = 0; $i < count($pages); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20"><a href="<?=$pages[$i]->myhost.$pages[$i]->mypath?>" target="_blank"><img src="<?=$plugin_url?>/img/watch-visitors/flowchart-row-link.png" style="margin-top: 5px;" border="0" /></a></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$pages[$i]->myhost.$pages[$i]->mypath?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=number_format(floatval($pages[$i]->avg_time), 2)?> seconds</td>
                        </tr>
                    <?
                }

                if (count($pages) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                <? } ?>
            </table>
            
            <div id="list2-top2"><font>Top Referral Keywords</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $results = $wpdb->get_results('select keyword, count(ssid) as counter  
                                            from tr_visits 
                                            where 
                                                    start_time>"'.$start_time.'" 
                                                and start_time<"'.$end_time.'" 
                                                and keyword!=""
                                            group by keyword order by counter desc limit 0,5;');

                for ($i = 0; $i < count($results); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20">&nbsp;</td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$results[$i]->keyword?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=$results[$i]->counter?> visits</td>
                        </tr>
                    <?
                }

                if (count($results) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <?
                } ?>
            </table> 
            
            <div id="list2-top2"><font>Top Referral Sites</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $results = $wpdb->get_results('select referer, count(ssid) as counter  
                                            from tr_visits 
                                            where 
                                                    start_time>"'.$start_time.'" 
                                                and start_time<"'.$end_time.'" 
                                                and referer!=""
                                                and seid=0 
                                            group by referer order by counter desc limit 0,5;');

                for ($i = 0; $i < count($results); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20"><a href="<?=$results[$i]->referer?>" target="_blank"><img src="<?=$plugin_url?>/img/watch-visitors/flowchart-row-link.png" style="margin-top: 5px;" border="0" /></a></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$results[$i]->referer?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=$results[$i]->counter?> visits</td>
                        </tr>
                    <?
                }  

                if (count($results) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <?
                } ?>
            </table>
            
            <div id="list2-top2"><font>Most Used Browsers</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $results = $wpdb->get_results('select browser, count(ssid) as counter  
                                            from tr_visits 
                                            where 
                                                    start_time>"'.$start_time.'" 
                                                and start_time<"'.$end_time.'"  
                                            group by browser order by counter desc limit 0,5;');

                $totals = 0; for ($i = 0; $i < count($results); $i++) $totals+= $results[$i]->counter;

                for ($i = 0; $i < count($results); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20">&nbsp;</td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$results[$i]->browser?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=( ($totals > 0) ? number_format($results[$i]->counter * 100 / $totals, 2) : 0 )?>%</td>
                        </tr>
                    <?
                }

                if (count($results) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <?
                } ?>
            </table>
            
            <div id="list2-top2"><font>Most Used OS</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $results = $wpdb->get_results('select v_os, v_os_version, count(ssid) as counter  
                                            from tr_visits 
                                            where 
                                                    start_time>"'.$start_time.'" 
                                                and start_time<"'.$end_time.'"  
                                            group by v_os, v_os_version order by counter desc limit 0,5;');   

                $totals = 0; for ($i = 0; $i < count($results); $i++) $totals+= $results[$i]->counter;

                for ($i = 0; $i < count($results); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20">&nbsp;</td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$results[$i]->v_os.' '.$results[$i]->v_os_version?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=( ($totals > 0) ? number_format($results[$i]->counter * 100 / $totals, 2) : 0 )?>%</td>
                        </tr>
                    <?
                } 

                if (count($results) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <?
                } ?>
            </table>
            
            <div id="list2-top2"><font>Most Used Screen Resolutions:</font></div>         
            <table width="99%" cellpadding="0" cellspacing="0">  
                <?     

                $results = $wpdb->get_results('select scrw, scrh, count(ssid) as counter  
                                            from tr_visits 
                                            where 
                                                    start_time>"'.$start_time.'" 
                                                and start_time<"'.$end_time.'"  
                                            group by scrw, scrh order by counter desc limit 0,5;');

                $totals = 0; for ($i = 0; $i < count($results); $i++) $totals+= $results[$i]->counter;

                for ($i = 0; $i < count($results); $i++) {
                    $thetd = ($i % 2) + 1;
                    ?>
                        <tr>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="20">&nbsp;</td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered"><?=$results[$i]->scrw.'x'.$results[$i]->scrh?></td>
                            <td valign="top" align="left" class="list2-td<?=$thetd?> list2-bordered" width="150"><?=( ($totals > 0) ? number_format($results[$i]->counter * 100 / $totals, 2) : 0 )?>%</td>
                        </tr>
                    <?
                } 

                if (count($results) == 0) {
                    ?>
                    <tr>
                        <td class="list2-td1 list2-bordered" width="20"></td>
                        <td colspan="2" valign="top" align="left" class="list2-td1 list2-bordered"><i>(no data available)</i></td>
                    </tr>
                    <?
                } ?>
            </table>   
                          
            
        </div>
        <div id="list2-bottom"></div>
    </div>
            

<?

$reportcontent = ob_get_contents();
ob_end_clean();

$fname = Code(10, 10);

$file = fopen($plugin_abs.'/tracker/reports/'.$fname.'.html', 'w');

fwrite($file, $reportcontent);

fclose($file);

$link = get_option('home').'/wp-admin/admin.php?page=wpc-other-options&display-report='.$fname;

$mail = new CMail();
$mail->from = 'noreply@wpclicks.com';
$mail->fromName = 'WPClicks';

$mail->to = get_option('wpc_report_email');
$mail->subject = 'New report generated at '.get_option('home');

$mail->message = 'Hi,
WPClicks has created a new site usage report for your site: '.get_option('home').'.

To check it out, simply click on the link below. If your email client does not support hyperlinks, copy the URL and open it in a browser.

'.$link.'

All the best,
WPClicks Team

';

$mail->send();


?>
