<?php

$time = time();

if (!isset($_COOKIE['end_date'])) { 
    $EndDate = mktime(23, 59, 59, date('m'), date('d'), date('Y'));               
} else { 
    $time = strtotime($_COOKIE['end_date']);
    $EndDate = mktime(23, 59, 59, date('m', $time), date('d', $time), date('Y', $time));         
}     

if (!isset($_COOKIE['start_date'])) { 
    $StartDate = $time - 14*24*3600 + 1;             
} else { 
    $time = strtotime($_COOKIE['start_date']);
    $StartDate = mktime(23, 59, 59, date('m', $time), date('d', $time), date('Y', $time));       
}

if (!isset($filters['spp']))            { $ShowPerPage      = 25;                       } else { $ShowPerPage   = $filters['spp'];              } 
  
?>

<script language="javascript" src="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../js/jquery.js"></script>
<script language="javascript" src="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../js/ui.datepicker.js"></script>

<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/ui.all.css" />
<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/watch-visitors.css" />
<link type="text/css" rel="stylesheet" href="<?=WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__))?>../css/listbox.css" />
<style>

.ui-state-highlight {
      background: inerhit;
}      

</style>

<script language="javascript">

var Today = '<?=date('Y-m-d', time())?>'; 

var StartDate = '<?=date('Y-m-d', $StartDate)?>';
var EndDate = '<?=date('Y-m-d', $EndDate)?>';
        
$(document).ready(function() {
            
    var T = Today.split('-');
    var Now = new Date(T[0], T[1]-1, T[2]);
    
    var ST = StartDate.split('-');
    var Start = new Date(ST[0], ST[1] - 1, ST[2]);
    
    dif = parseInt( (Now.getTime() - Start.getTime()) / (1000 * 3600 * 24) );
                   
    $("#startdate").datepicker({
        dateFormat: 'yy-mm-dd',
        defaultDate: '-' + dif + 'd',
        maxDate: 0,
        gotoCurrent: true, 
        currentText: 'Current', 
        onSelect: function(dateText) { 
            StartDate = dateText;                                                                                                  
            window.location = '<?=get_option('home')?>/?change-date&start_date=' + StartDate + '&end_date=' + EndDate + '&ret=wpc-search';
        }     
    });
    $("#startdate").val(StartDate);
    
    var EN = EndDate.split('-');
    var End = new Date(EN[0], EN[1] - 1, EN[2]);
    
    dif = parseInt( (Now.getTime() - End.getTime()) / (1000 * 3600 * 24) );
              
    $("#enddate").datepicker({
        dateFormat: 'yy-mm-dd',
        defaultDate: '-' + dif + 'd',
        maxDate: 0,
        gotoCurrent: true, 
        currentText: 'Current',
        onSelect: function(dateText) { 
            EndDate = dateText;                                                                                                    
            window.location = '<?=get_option('home')?>/?change-date&start_date=' + StartDate + '&end_date=' + EndDate + '&ret=wpc-search';  
        } 
    });
    $("#enddate").val(EndDate);
    
});


function Togle(id) {
    var my = document.getElementById(id);
    
    if (my.style.display == 'none') {
        $(my).slideDown();
    } else {
        $(my).slideUp();
    }
}   

</script>                

<div id="blue">
    <div id="dates">
        <table cellpadding="0" cellspacing="0">
            <tr>
                <td valign="middle" align="center" width="150"><div id="date-textfield"><input type="text" name="startdate" id="startdate"></div></td>
                <td valign="middle" align="center" width="15"><font style="color: #fff; font-size: 15px;">To</font></td>
                <td valign="middle" align="center" width="150"><div id="date-textfield"><input type="text" name="enddate" id="enddate"></div></td>
                <td valign="middle" align="center"><div id="date-icon"></div></td>
            </tr>
        </table>
                
    </div>
</div>                    

<div style="clear: both;"></div>
<div id="show-per-page" style="display: <?=($hideswitch == 1) ? 'none' : 'block'?>;">      
     <table cellpadding="0" cellspacing="">
        <tr>
            <td valign="middle" align="center"><b>Show Per Page:</b></td>
            <!--<td valign="middle" align="center"><div id="<?= ($filters['spp'] == '1') ? 'spp-blue' : 'spp-gray' ?>" onclick="javascript: window.location = '<?=get_option('home')?>/?change-filter&filter=spp&val=1&ret=wpc-visitors';">1</a></td>-->
            <td valign="middle" align="center"><div id="<?= ($filters['spp'] == '10') ? 'spp-blue' : 'spp-gray' ?>" onclick="javascript: window.location = '<?=get_option('home')?>/?change-filter&filter=spp&val=10&ret=wpc-search';">10</a></td>
            <td valign="middle" align="center"><div id="<?= ($filters['spp'] == '25') ? 'spp-blue' : 'spp-gray' ?>" onclick="javascript: window.location = '<?=get_option('home')?>/?change-filter&filter=spp&val=25&ret=wpc-search';">25</a></td>
            <td valign="middle" align="center"><div id="<?= ($filters['spp'] == '50') ? 'spp-blue' : 'spp-gray' ?>" onclick="javascript: window.location = '<?=get_option('home')?>/?change-filter&filter=spp&val=50&ret=wpc-search';">50</a></td>
        </tr>
     </table>
</div> 
