<?php

$StartFrom = 0;
$mypage = 1;
if (isset($_GET['start'])) {
    $StartFrom = $_GET['start'];
    $mypage = floor($StartFrom / $ShowPerPage) + 1; 
}

$query = 'select 
                count(tt.pgid) as counter
            from 
                tr_pages tt, tr_visits v 
            where 
                    tt.wp_search_key!="" 
                and tt.ssid=v.ssid
                and tt.last_update>'.$StartDate.' 
                and tt.last_update<'.$EndDate.'
            group by tt.wp_search_key;';

$totals = $wpdb->get_results($query);
$totals = $totals[0]->counter;

$query2 = 'select 
                tt.pgid, tt.wp_search_key, 
                count(tt.pgid) as counter, 
                min(tt.wp_search_results) as xmin, 
                max(tt.wp_search_results) as xmax, 
                avg(tt.wp_search_results) as xavg, 
                count(t.pgid) as success
            from 
                tr_visits v, tr_pages tt
            left join 
                    tr_pages t 
                on 
                    tt.pgid=t.pgid 
                and t.wp_search_results>0
            where 
                    tt.wp_search_key!=""
                and tt.ssid=v.ssid 
                and tt.last_update>'.$StartDate.' 
                and tt.last_update<'.$EndDate.'
            group by tt.wp_search_key 
            order by counter desc  
            limit '.$StartFrom.', '.$ShowPerPage.';';   
//print $query2;            
$searches = $wpdb->get_results($query2);
            
$min = 0;
$max = ceil($totals / $ShowPerPage) + 1;

$pages = array();
for ($i = $mypage - 5; $i < $mypage; $i++) {
    if ($i > 0) {
        $newstart = ($i - 1) * $ShowPerPage; if ($newstart < 0) $newstart = 0;
        array_push($pages, array('page' => $i, 'link' => 'admin.php?page=wpc-search&start='.$newstart));
    }
}

array_push($pages, array('page' => $mypage, 'link' => ''));

for ($i = $mypage + 1; $i <= $mypage + 5; $i++) {
    if ($i < $max) {
        $newstart = ($i - 1) * $ShowPerPage; 
        
        if ($newstart < 0) $newstart = 0; 
//        if ($newstart > $totals[0][0]) $newstart = $totals[0][0] - $ShowPerPage; 
        
        array_push($pages, array('page' => $i, 'link' => 'admin.php?page=wpc-visitors&'.$newstart));
    }
}           
            

  
?>
