<?php

error_reporting(E_ALL);
ini_set('display_errors','Off');

ini_set('error_log','errors.log');
header('p3p: CP="NOI CURa ADMa DEVa TAIa OUR BUS IND UNI COM NAV INT"'); 

include 'myDB.php';

$db = new myDB();  

function GetBrowser() {
    
    $UA = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '';
    
    $SF = strstr($UA, 'Safari') ? true : false;
    
    $OP = strstr($UA, 'Opera') ? true : false;
    $OPV = $OP ? preg_split('/opera\//i', $UA) : false;
    $OPV = $OPV ? floatval($OPV[1]) : false;
    
    $FF = !$OP && strstr($UA, 'Firefox') ? true : false;
    $FFV = $FF ? preg_split('/firefox\//i', $UA) : false;
    $FFV = $FFV ? floatval($FFV[1]) : false;
    
    $IE = !$OP && !$FF && strstr($UA, 'MSIE') ? true : false;
    $IEV = $IE ? preg_split('/msie/i', $UA) : false;
    $IEV = $IEV ? floatval($IEV[1]) : false;
    
    if ($IE) {
        return 'Internet Explorer';
    }
    
    if ($FF) {
        return 'Firefox';
    }
    
    if ($OP) {
        return 'Opera';
    }
    
    if ($SF) {
        return 'Safari';
    }
    
}

function GetSystemInfo() {
    include 'detect_bs.php';
    
    $full = '';
    // change these two to match your include path/and file name you give the script
    //include('browser_detection.php');
    $browser_info = browser_detection('full');

    $browser_info[] = browser_detection('moz_version');

    switch ($browser_info[5])
    {
        case 'win':
            $os .= 'Windows ';
            break;
        case 'nt':
            $os .= 'Windows ';
            break;
        case 'lin':
            $os .= 'Linux  ';
            break;
        case 'mac':
            $os .= 'Mac ';
            break;
        case 'unix':
            $os .= 'Unix ';
            break;
        default:
            $os .= $browser_info[5];
    }
    $v = '';
    if ( $browser_info[5] == 'nt' )
    {
        if ($browser_info[6] == 5)
        {
            $v = '2000';
        }
        elseif ($browser_info[6] == 5.1)
        {
            $v = 'XP';
        }
        elseif ($browser_info[6] == 5.2)
        {
            $v = 'XP x64 Edition/Server 2003';
        }
        elseif ($browser_info[6] == 6.0)
        {
            $v = 'Vista';
        }
        elseif ($browser_info[6] == 6.1)
        {
           $v = '7';
        }
    }
    elseif ( ( $browser_info[5] == 'mac' ) &&  ( $browser_info[6] >= 10 ) )
    {
        $v = 'OS X';
    }
    elseif ( $browser_info[5] == 'lin' )
    {
        $v = ( $browser_info[6] != '' ) ? ' ' . ucfirst ($browser_info[6] ) : ' ';
    }
    elseif ( $browser_info[6] == '' )
    {
        $v = ' ';
    }
    else
    {
        $v = strtoupper( $browser_info[6] );
    }
    
    return array($os, $v);
}


// now check if any session was opened before
if (!isset($_SESSION['MySSID'])) {          
    
    // get system info
    $yasystem = GetSystemInfo();
    // insert new row in sessions table
    $sql = 'insert into tr_visits (start_time, ip, user_agent, browser, url, v_os, v_os_version) values 
            ("'.time().'", "'.$_SERVER['REMOTE_ADDR'].'", "'.$_SERVER['HTTP_USER_AGENT'].'", 
            "'.GetBrowser().'", "", "'.$yasystem[0].'", "'.$yasystem[1].'")';
            
    $results = $db->dbQuery($sql);  
            
    $MySSID = $_SESSION['MySSID'] = $db->insertId();
    
    // now check for a previous session 
    $sql = 'select ssid 
                from 
                    tr_visits 
                where 
                    ssid>"'.($MySSID-10).'" and 
                    ssid<"'.$MySSID.'" and 
                    ip="'.$_SERVER['REMOTE_ADDR'].'" and 
                    browser="'.GetBrowser().'" and 
                    v_os="'.$yasystem[0].'"
                limit 0,1;';
    $prssid = $db->FetchArrays($sql);
    
    if ($prssid) {
        // move the old ones to new ones
        $db->dbQuery('update tr_pages set ssid="'.$MySSID.'" where ssid="'.$prssid[0]->ssid.'"');
        
        $db->dbQuery('delete from tr_visits where ssid="'.$prssid[0]->ssid.'" limit 1');
    }
        
        
        
    
} else {
    $MySSID = $_SESSION['MySSID'];

}

include 'js.php';        

?>